/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2004 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2001-2004 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: ip6_var.h,v 1.2.1.1 2004/10/13 06:00:55 abe Exp abe $
 */

/*	$FreeBSD: src/sys/netinet6/ip6_var.h,v 1.10 2002/10/16 01:54:45 sam Exp $	*/
/*	$KAME: ip6_var.h,v 1.62 2001/05/03 14:51:48 itojun Exp $	*/

/*
 * Copyright (C) 1995, 1996, 1997, and 1998 WIDE Project.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the project nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE PROJECT AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE PROJECT OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * Copyright (c) 1982, 1986, 1993
 *	The Regents of the University of California.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by the University of
 *	California, Berkeley and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *	@(#)ip_var.h	8.1 (Berkeley) 6/10/93
 */
 
#ifndef _IP6_VAR_H_
#define _IP6_VAR_H_

#ifdef SUPPORT_INET6

/*
 *  IPv6 إåڥɥޥ
 */

#define IF_IP6_HDR_SIZE			(sizeof(T_IF_HDR) + IP6_HDR_SIZE)

#define GET_IP6_HDR(nbuf)		((T_IP6_HDR*)((nbuf)->buf + sizeof(T_IF_HDR)))
#define GET_IP6_SDU(nbuf)		((UB*)((nbuf)->buf) + GET_IF_IP6_HDR_SIZE(nbuf))
#define GET_IP6_NEXT_HDR(nbuf)		((UB*)((nbuf)->buf) + IF_IP6_HDR_SIZE)

#define GET_IP6_HDR_SIZE(iph)		(get_ip6_hdr_size(iph))
#define GET_IP6_SDU_SIZE(iph)		(ntohs((iph)->plen))
#define GET_IF_IP6_HDR_SIZE(nbuf)	(sizeof(T_IF_HDR) + (GET_IP6_HDR_SIZE(GET_IP6_HDR(nbuf))))

#define SET_IP6_SDU_SIZE(iph,slen)	((iph)->plen=htons(slen))

/* ip6_output Υե饰 */

#define IPV6_OUT_FLG_DAD		0x0100	/* ʣɥ쥹	*/
#define IPV6_OUT_FLG_HOP_LIMIT		0x0200	/* ۥåץߥåȻ	*/

/* ۥåץߥåȥե饰դۥåץߥåͤޥ */

#define IPV6_OUT_GET_HOP_LIMIT(f)	((f)&0x00ff)
#define IPV6_OUT_SET_HOP_LIMIT(f,l)	((f)|(l))

/*
 *  ip6_unknown_opt -- ̤ΤΥץν
 *
 *    :
 *
 *      0 ʾ 			ץĹ
 *      IP6_OPT_RET_ERR (-1)	顼ƽ¦ǥͥåȥХåե롣
 *      IP6_OPT_RET_REL (-2)	顼ͥåȥХåեϳƤ롣
 */

#define IP6_OPT_RET_ERR		(-1)
#define IP6_OPT_RET_REL		(-2)

/*
 *  IPv4  IPv6 򥳥ѥ򤹤뤿Υޥ
 */

#define IF_IP_HDR_SIZE			IF_IP6_HDR_SIZE

#define GET_IP_HDR(nbuf)		GET_IP6_HDR(nbuf)
#define GET_IP_SDU(nbuf)		GET_IP6_SDU(nbuf)

#define GET_IP_HDR_SIZE(iph)		GET_IP6_HDR_SIZE(iph)
#define GET_IP_SDU_SIZE(iph)		GET_IP6_SDU_SIZE(iph)
#define GET_IF_IP_HDR_SIZE(nbuf)	GET_IF_IP6_HDR_SIZE(nbuf)

#define SET_IP_SDU_SIZE(iph,len)	SET_IP6_SDU_SIZE(iph,len)

#define IP_OUTPUT(nbuf,tmout)		ip6_output(nbuf,0,tmout)
#define IP_INIT()			ip6_init()
#define IP_REMOVE_OPTIONS(nbuf)		ip6_remove_exthdrs(nbuf)
#define IP_UPDATE_SDU_LEN(iph,diff)	((iph)->plen=htons(ntohs((iph)->plen)-(diff)))

#ifdef SUPPORT_MIB

/*
 *  SNMP  ١ (MIB)
 */

typedef struct t_in6_ifstat {
	UW	ipv6IfStatsInReceives;
	UW	ipv6IfStatsInHdrErrors;
/*	UW	ipv6IfStatsInTooBigErrors;*/
/*	UW	ipv6IfStatsInNoRoutes;*/
	UW	ipv6IfStatsInAddrErrors;
	UW	ipv6IfStatsInUnknownProtos;
	UW	ipv6IfStatsInTruncatedPkts;
/*	UW	ipv6IfStatsInDiscards;*/
/*	UW	ipv6IfStatsInDelivers;*/
/*	UW	ipv6IfStatsOutForwDatagrams;*/
	UW	ipv6IfStatsOutRequests;
	UW	ipv6IfStatsOutDiscards;
/*	UW	ipv6IfStatsOutFragOKs;*/
/*	UW	ipv6IfStatsOutFragFails;*/
/*	UW	ipv6IfStatsOutFragCreates;*/
/*	UW	ipv6IfStatsReasmReqds;*/
/*	UW	ipv6IfStatsReasmOKs;*/
/*	UW	ipv6IfStatsReasmFails;*/
	UW	ipv6IfStatsInMcastPkts;
	UW	ipv6IfStatsOutMcastPkts;
} T_IN6_IFSTAT;

extern T_IN6_IFSTAT in6_ifstat;

#endif	/* of #ifdef SUPPORT_MIB */

/*
 *  ؿ
 */

extern ER ip6_output (T_NET_BUF *output, int flags, TMO tmout);
extern void ip6_init (void);
extern int get_ip6_hdr_size (T_IP6_HDR *iph);
extern int ip6_nexthdr (T_NET_BUF *nbuf, int off, int proto, int *nextp);
extern ER_UINT ip6_lasthdr (T_NET_BUF *nbuf, int off, int proto, int *nextp);
extern int ip6_unknown_opt (T_NET_BUF *input, UB *opt);
extern int dest6_input (T_NET_BUF *input, int *offp);
extern int route6_input (T_NET_BUF *input, int *offp);
extern int frag6_input (T_NET_BUF *input, int *offp);
extern ER ip6_remove_exthdrs (T_NET_BUF *nbuf);

#endif	/* of #ifdef SUPPORT_INET6 */

#endif	/* of #ifndef _IP6_VAR_H_ */
